from pydantic import BaseModel, ConfigDict, Field
from typing import Any, Dict, Optional, Type

from ..models.create_spreadsheet_response_properties_default_format_background_color import (
    CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColor,
)
from ..models.create_spreadsheet_response_properties_default_format_padding import (
    CreateSpreadsheetResponsePropertiesDefaultFormatPadding,
)
from ..models.create_spreadsheet_response_properties_default_format_text_format import (
    CreateSpreadsheetResponsePropertiesDefaultFormatTextFormat,
)
from ..models.create_spreadsheet_response_properties_default_format_background_color_style import (
    CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyle,
)


class CreateSpreadsheetResponsePropertiesDefaultFormat(BaseModel):
    """
    Attributes:
        wrap_strategy (Optional[str]): Defines how text is wrapped in cells by default. Example: OVERFLOW_CELL.
        text_format (Optional[CreateSpreadsheetResponsePropertiesDefaultFormatTextFormat]):
        background_color (Optional[CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColor]):
        background_color_style (Optional[CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyle]):
        padding (Optional[CreateSpreadsheetResponsePropertiesDefaultFormatPadding]):
        vertical_alignment (Optional[str]): The default vertical alignment for cell content. Example: BOTTOM.
    """

    model_config = ConfigDict(extra="allow", populate_by_name=True)

    wrap_strategy: Optional[str] = Field(alias="wrapStrategy", default=None)
    text_format: Optional[
        "CreateSpreadsheetResponsePropertiesDefaultFormatTextFormat"
    ] = Field(alias="textFormat", default=None)
    background_color: Optional[
        "CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColor"
    ] = Field(alias="backgroundColor", default=None)
    background_color_style: Optional[
        "CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyle"
    ] = Field(alias="backgroundColorStyle", default=None)
    padding: Optional["CreateSpreadsheetResponsePropertiesDefaultFormatPadding"] = (
        Field(alias="padding", default=None)
    )
    vertical_alignment: Optional[str] = Field(alias="verticalAlignment", default=None)

    def to_dict(self) -> Dict[str, Any]:
        return self.model_dump(exclude_none=True, by_alias=True)

    @classmethod
    def from_dict(
        cls: Type["CreateSpreadsheetResponsePropertiesDefaultFormat"],
        src_dict: Dict[str, Any],
    ):
        return cls.model_validate(src_dict)

    @property
    def additional_keys(self) -> list[str]:
        base_fields = self.model_fields.keys()
        return [k for k in self.__dict__ if k not in base_fields]

    def __getitem__(self, key: str) -> Any:
        if key in self.__dict__:
            return self.__dict__[key]
        raise KeyError(key)

    def __setitem__(self, key: str, value: Any) -> None:
        self.__dict__[key] = value

    def __delitem__(self, key: str) -> None:
        if key in self.__dict__:
            del self.__dict__[key]
        else:
            raise KeyError(key)

    def __contains__(self, key: str) -> bool:
        return key in self.__dict__
