from pydantic import BaseModel, ConfigDict, Field
from typing import Any, Dict, Optional, Type

from ..models.create_spreadsheet_response_properties_default_format_background_color_style_rgb_color import (
    CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyleRgbColor,
)


class CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyle(BaseModel):
    """
    Attributes:
        rgb_color (Optional[CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyleRgbColor]):
    """

    model_config = ConfigDict(extra="allow", populate_by_name=True)

    rgb_color: Optional[
        "CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyleRgbColor"
    ] = Field(alias="rgbColor", default=None)

    def to_dict(self) -> Dict[str, Any]:
        return self.model_dump(exclude_none=True, by_alias=True)

    @classmethod
    def from_dict(
        cls: Type[
            "CreateSpreadsheetResponsePropertiesDefaultFormatBackgroundColorStyle"
        ],
        src_dict: Dict[str, Any],
    ):
        return cls.model_validate(src_dict)

    @property
    def additional_keys(self) -> list[str]:
        base_fields = self.model_fields.keys()
        return [k for k in self.__dict__ if k not in base_fields]

    def __getitem__(self, key: str) -> Any:
        if key in self.__dict__:
            return self.__dict__[key]
        raise KeyError(key)

    def __setitem__(self, key: str, value: Any) -> None:
        self.__dict__[key] = value

    def __delitem__(self, key: str) -> None:
        if key in self.__dict__:
            del self.__dict__[key]
        else:
            raise KeyError(key)

    def __contains__(self, key: str) -> bool:
        return key in self.__dict__
